From d2d225c10cc65c99f4747c5604fd17942239ae39 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 23 2021 02:23:51 +0000
Subject: [PATCH 2158/2232] East const to make nested pointer types work


---

diff --git a/gen/src/write.rs b/gen/src/write.rs
index b3911c1..930ce0b 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -1173,17 +1173,31 @@ fn write_type(out: &mut OutFile, ty: &Type) {
             write!(out, ">");
         }
         Type::Ref(r) => {
-            if !r.mutable {
-                write!(out, "const ");
+            if let Type::Ptr(_) = r.inner {
+                write_type_space(out, &r.inner);
+                if !r.mutable {
+                    write!(out, "const");
+                }
+            } else {
+                if !r.mutable {
+                    write!(out, "const ");
+                }
+                write_type(out, &r.inner);
             }
-            write_type(out, &r.inner);
             write!(out, " &");
         }
         Type::Ptr(p) => {
-            if !p.mutable {
-                write!(out, "const ");
+            if let Type::Ptr(_) = p.inner {
+                write_type_space(out, &p.inner);
+                if !p.mutable {
+                    write!(out, "const");
+                }
+            } else {
+                if !p.mutable {
+                    write!(out, "const ");
+                }
+                write_type(out, &p.inner);
             }
-            write_type(out, &p.inner);
             write!(out, " *");
         }
         Type::Str(_) => {
diff --git a/syntax/check.rs b/syntax/check.rs
index a4cddfa..4c6d673 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -227,10 +227,6 @@ fn check_type_ref(cx: &mut Check, ty: &Ref) {
             cx.error(ty, "C++ does not allow references to references");
             return;
         }
-        Type::Ptr(_) => {
-            cx.error(ty, "support for reference to pointer is not implemented yet");
-            return;
-        }
         _ => return,
     }
 
@@ -244,10 +240,6 @@ fn check_type_ptr(cx: &mut Check, ty: &Ptr) {
             cx.error(ty, "C++ does not allow pointer to reference as a type");
             return;
         }
-        Type::Ptr(_) => {
-            cx.error(ty, "support for pointer to pointer is not implemented yet");
-            return;
-        }
         _ => return,
     }
 
diff --git a/tests/ui/ptr_unsupported.rs b/tests/ui/ptr_unsupported.rs
index ca1580a..9d59c03 100644
--- a/tests/ui/ptr_unsupported.rs
+++ b/tests/ui/ptr_unsupported.rs
@@ -3,9 +3,7 @@ mod ffi {
     unsafe extern "C++" {
         type C;
 
-        fn get_ptr_to_ptr() -> *mut *mut C;
         fn get_ptr_to_reference() -> *mut &C;
-        fn get_reference_to_ptr() -> &*mut C;
         fn get_uniqueptr_to_ptr() -> UniquePtr<*mut C>;
         fn get_vector_of_ptr() -> UniquePtr<CxxVector<*mut C>>;
     }
diff --git a/tests/ui/ptr_unsupported.stderr b/tests/ui/ptr_unsupported.stderr
index af5e134..41cea63 100644
--- a/tests/ui/ptr_unsupported.stderr
+++ b/tests/ui/ptr_unsupported.stderr
@@ -1,29 +1,17 @@
-error: support for pointer to pointer is not implemented yet
- --> $DIR/ptr_unsupported.rs:6:32
-  |
-6 |         fn get_ptr_to_ptr() -> *mut *mut C;
-  |                                ^^^^^^^^^^^
-
 error: C++ does not allow pointer to reference as a type
- --> $DIR/ptr_unsupported.rs:7:38
-  |
-7 |         fn get_ptr_to_reference() -> *mut &C;
-  |                                      ^^^^^^^
-
-error: support for reference to pointer is not implemented yet
- --> $DIR/ptr_unsupported.rs:8:38
+ --> $DIR/ptr_unsupported.rs:6:38
   |
-8 |         fn get_reference_to_ptr() -> &*mut C;
+6 |         fn get_ptr_to_reference() -> *mut &C;
   |                                      ^^^^^^^
 
 error: unsupported unique_ptr target type
- --> $DIR/ptr_unsupported.rs:9:38
+ --> $DIR/ptr_unsupported.rs:7:38
   |
-9 |         fn get_uniqueptr_to_ptr() -> UniquePtr<*mut C>;
+7 |         fn get_uniqueptr_to_ptr() -> UniquePtr<*mut C>;
   |                                      ^^^^^^^^^^^^^^^^^
 
 error: unsupported vector target type
-  --> $DIR/ptr_unsupported.rs:10:45
-   |
-10 |         fn get_vector_of_ptr() -> UniquePtr<CxxVector<*mut C>>;
-   |                                             ^^^^^^^^^^^^^^^^^^
+ --> $DIR/ptr_unsupported.rs:8:45
+  |
+8 |         fn get_vector_of_ptr() -> UniquePtr<CxxVector<*mut C>>;
+  |                                             ^^^^^^^^^^^^^^^^^^

